export declare type CacheRecord<T, K extends string | number> = Record<K, {
    lastFetchTimestamp: number;
    value?: T;
} | undefined>;
export declare class CachedDataContainer<T> {
    readonly valueGetterFn: (...args: any[]) => Promise<T | undefined>;
    readonly valueSetterFn?: ((value: T, ...args: any[]) => Promise<void>) | undefined;
    readonly dataRetentionDurationMs: number;
    private readonly cache;
    private readonly valueProvider;
    constructor(valueGetterFn: (...args: any[]) => Promise<T | undefined>, valueSetterFn?: ((value: T, ...args: any[]) => Promise<void>) | undefined, dataRetentionDurationMs?: number);
    getValue(...args: any[]): Promise<T | undefined>;
    setValue(value: T, ...args: any[]): Promise<void>;
}
