import { Constructor } from "../common/types";
import { DtoMetadata } from "./DtoMetadata";
export declare type DeepPartial<T> = {
    [P in keyof T]?: DeepPartial<T[P]>;
};
export declare const partialize: (metadata: DtoMetadata) => {
    ignoreCrud?: import("..").HttpMethod[] | undefined;
    relaxed?: boolean | undefined;
    description?: string | undefined;
    primitiveType?: import("..").DataType | undefined;
    fields: import("./DtoMetadata").DtoFieldMetadata[];
    id: string;
    constructorDependencies?: {
        ctor: import("../common/types").AbstractConstructor<any>;
        required: boolean;
    }[] | undefined;
};
export declare const DeepPartialClass: <T = any>(cls: Constructor<T>) => Constructor<DeepPartial<T>>;
