import { DtoMetadata } from "./DtoMetadata";
import { Identifiable } from "../model/Identifiable";
export declare const uniqueReducer: <T>(collection: T[], item: T) => T[];
export declare const deepMerge: (target: any, source: any, joinArray?: boolean) => void;
export declare const pickData: <T extends object, K extends keyof T>(data: T, fields: K[]) => Pick<T, K>;
export declare const omitData: <T extends object, K extends keyof T>(data: T, fields: K[]) => Omit<T, K>;
export declare const diffData: <T extends object>(oldObject: T | undefined, newObject: Partial<T> | undefined) => Partial<T> | undefined;
export declare const leanData: <T>(obj?: Partial<T> | undefined) => Partial<T> | undefined;
export declare const stripData: (value: any, metadata: DtoMetadata) => any;
export declare const diffNestedArray: <T extends Identifiable<string | number>>(newData: Partial<T>[], oldData: Partial<T>[]) => Partial<T>[] | undefined;
export declare const validateData: (value: any, metadata: DtoMetadata, fillDefault?: boolean) => any;
