import { OrderDirection } from "./OrderDirection";
import { DeepPartial } from "../dto/deep-partial";
import { AbstractModel } from "../model/AbstractModel";
export declare type GetManyQueryCondition<T> = {
    [k in keyof T]?: T[k] extends AbstractModel ? GetManyQueryCondition<T[k]> : T[k] extends AbstractModel[] ? GetManyQueryCondition<T[k][number]> : any;
};
export declare class FieldsQuery<T> {
    fields?: GetManyQueryCondition<T>;
}
export declare class CreateManyRequestBody<T> {
    records: DeepPartial<T>[];
}
export declare class CreateManyResponseBody<T> {
    records: DeepPartial<T>[];
}
export declare class IdParam {
    id: string;
}
export declare class PaginationQueries {
    limit?: number;
    page?: number;
}
export declare class SearchQueries {
    search?: string;
}
export declare class LocaleQueries {
    locale?: string;
}
declare const GetManyQueries_base: import("..").Constructor<PaginationQueries & SearchQueries & LocaleQueries>;
export declare class GetManyQueries<T> extends GetManyQueries_base {
    fields?: GetManyQueryCondition<T>;
    order?: {
        [k in keyof T]?: OrderDirection;
    }[] | "random";
    projection?: (keyof T)[];
}
export declare class GetManyResponseBody<T> {
    total: number;
    records: DeepPartial<T>[];
}
export declare class UpdateManyQueries<T> {
    fields?: GetManyQueryCondition<T>;
    returning?: boolean;
}
export declare class UpdateManyResponse<T> {
    modified: DeepPartial<T>[];
}
export declare class UpdateManyBody<T> {
    update: DeepPartial<T>;
}
export {};
